Object.defineProperty(exports, "__esModule", { value: true });
var GeneratorSeedIterator = /** @class */ (function () {
    function GeneratorSeedIterator(seed, nextFunction) {
        this.seed = seed;
        this.nextFunction = nextFunction;
    }
    GeneratorSeedIterator.prototype.next = function (value) {
        if (this.prevItem == null) {
            this.prevItem = this.seed;
            return { done: false, value: this.seed };
        }
        var nextItem = this.nextFunction(this.prevItem);
        if (nextItem == null) {
            return { done: true, value: undefined };
        }
        this.prevItem = nextItem;
        return {
            done: false,
            value: nextItem
        };
    };
    return GeneratorSeedIterator;
}());
exports.default = GeneratorSeedIterator;
//# sourceMappingURL=GeneratorSeedIterator.js.map