import Sequence from "./Sequence";
export interface JoinConfig<T> {
    value?: string;
    separator?: string;
    prefix?: string;
    postfix?: string;
    limit?: number;
    truncated?: string;
    transform?: (value: T) => string;
}
export declare class JoinToString {
    /**
     * Joins all elements of the sequence into a string with the given configuration.
     *
     * @param {JoinConfig<T>} config
     * @returns {string}
     */
    joinToString<T>(this: Sequence<T>, config?: JoinConfig<T>): string;
    /**
     * Joins all elements of the sequence into a string with the given configuration.
     *
     * @param {JoinConfig<T>} config
     * @returns {string}
     */
    joinTo<T>(this: Sequence<T>, config?: JoinConfig<T>): string;
}
