import Sequence from "./Sequence";
export declare class LastOrNull {
    /**
     * Returns the last element of the sequence or the last element matching `predicate` if present, otherwise returns `null`.
     *
     * @param {(value: T) => boolean} predicate
     * @returns {T}
     */
    lastOrNull<T>(this: Sequence<T>, predicate?: (value: T) => boolean): T | null;
    /**
     * Returns the last element of the sequence or the last element matching `predicate` if present, otherwise returns `null`.
     *
     * @param {(value: T) => boolean} predicate
     * @returns {T}
     */
    findLast<T>(this: Sequence<T>, predicate?: (value: T) => boolean): T | null;
}
