import Sequence from "./Sequence";
export declare class Plus {
    /**
     * Appends the given `element` to the end of the sequence and returns a new sequence.
     *
     * @param {T} element
     * @returns {Sequence<T>}
     */
    plus<T>(this: Sequence<T>, element: T): Sequence<T>;
    /**
     * Appends the given array to the end of the sequence and returns a new sequence.
     *
     * @param {Array<T>} other
     * @returns {Sequence<T>}
     */
    plus<T>(this: Sequence<T>, other: Array<T>): Sequence<T>;
    /**
     * Appends the given sequence to the end of the sequence and returns a new sequence.
     *
     * @param {Sequence<T>} other
     * @returns {Sequence<T>}
     */
    plus<T>(this: Sequence<T>, other: Sequence<T>): Sequence<T>;
}
