import Sequence from "./Sequence";
import ComparatorFactory from "./ComparatorFactory";
import Comparator from "./Comparator";
export declare class Sorted {
    /**
     * Returns a new sequence with all elements sorted by the comparator specified by the given `composeComparator` function
     * or in natural order if no arguments are given.
     *
     * @returns {Sequence<T>}
     */
    sorted<T>(this: Sequence<T>, composeComparator?: (factory: ComparatorFactory<T>) => Comparator<T>): Sequence<T>;
}
